<?php

namespace STM\Match\Action\Player;

use STM\Match\Lineup\MatchPlayer;
use \Exception;
use STM\StmFactory;

/**
 * Test class for MatchPlayerActionValidator.
 * Generated by PHPUnit on 2012-07-12 at 09:36:24.
 * @group match_action
 */
class MatchPlayerActionValidatorTest extends \PHPUnit_Framework_TestCase {

    private $valid_structure;

    protected function setUp() {
        $this->valid_structure = array(
            'match_player' => StmFactory::find()->MatchPlayer->findById(1),
            'match_action' => StmFactory::find()->MatchAction->findById(1), 
            'minute_action' => '15', 
            'action_comment' => '',
        );
    }

    public function testCheck_create() {
        // argument must be array with keys match_player, match_action, minute_action, action_comment
        $this->assert_bad_arguments('checkCreate', null);
        // match_player must be instanceof MatchPlayer
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('match_player', null));
        // match_action must be instanceof MatchAction
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('match_action', new Exception()));
        // minute_action must be string <1, 20>
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('minute_action', '1234567890123456789012345'));
        // action_comment must be string <0, 200>
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('action_comment', new Exception()));
        // match_player & action & minute must be unique
        if ($this->valid_structure['match_player'] && $this->valid_structure['match_action']) {
            $match_player_action = StmFactory::find()->MatchPlayerAction->findById($this->valid_structure['match_player'], $this->valid_structure['match_action'], $this->valid_structure['minute_action']);
            if ($match_player_action) {
                $this->assert_bad_arguments('checkCreate', $this->valid_structure);
                // if minute_action is modified -> OK (if not exists)
                $this->valid_structure['minute_action'] .= 'a*a*a';
                parent::assertTrue(MatchPlayerActionValidator::checkCreate($this->valid_structure));
            } else {
                parent::assertTrue(MatchPlayerActionValidator::checkCreate($this->valid_structure));
            }
        }
    }

    public function testCheck_update() {
        // compared object must be set
        $this->assert_bad_arguments('checkUpdate', array('minute_action' => '5', 'action_comment' => '100'));
        $match_player_action = StmFactory::find()->MatchPlayerAction->findById($this->valid_structure['match_player'], $this->valid_structure['match_action'], $this->valid_structure['minute_action']);
        if ($match_player_action) {
            MatchPlayerActionValidator::setMatchPlayerAction($match_player_action);
            // at least one value must be different
            $arr = $match_player_action->toArray();
            $this->assert_bad_arguments('checkUpdate', array('minute_action' => $arr['minute_action'],'action_comment' => $arr['action_comment']));
            MatchPlayerActionValidator::resetMatchPlayerAction();
        }
    }

    private function get_modified_structure($key, $new_value) {
        $attributes = $this->valid_structure;
        $attributes[$key] = $new_value;
        return $attributes;
    }
    
    private function assert_bad_arguments($method, $data) {
        MatchPlayerActionValidator::init();
        parent::assertFalse(MatchPlayerActionValidator::$method($data));
        MatchPlayerActionValidator::init();
    }
}

?>
